Attribute VB_Name = "DXFunctions"
Option Explicit

Public DX As New DirectX7  '   DirectX7
Public dd As DirectDraw7  '   DirectDraw7.

Public ddsdPrimary As DDSURFACEDESC2
Public ddsdBack As DDSURFACEDESC2

Public Primary As DirectDrawSurface7
Public Back As DirectDrawSurface7
Public DDClip As DirectDrawClipper

Public ddsd1 As DDSURFACEDESC2
Public ddsd2 As DDSURFACEDESC2

Public m_ds As DirectSound
Public bufferDesc As DSBUFFERDESC
Public waveFormat As WAVEFORMATEX


Declare Function ShowCursor Lib "User32" (ByVal bShow As Long) As Long 'API   / 
Public lShowCursor As Long '
Public lRet As Long '


Public Sub HideMouse() 'Sub,   
    Do
    lShowCursor = lShowCursor - 1
    lRet = ShowCursor(False)
    Loop Until lRet < 0
End Sub

Public Sub ShowMouse() 'Sub,   
    Do
    lShowCursor = lShowCursor - 1
    lRet = ShowCursor(True)
    Loop Until lRet >= 0
End Sub

Public Function DXInitWindowDraw(WorkForm As Form) As Boolean
    On Local Error GoTo errOut
    
    Set dd = DX.DirectDrawCreate("")
    WorkForm.Show
    '   (..  )  
    Call dd.SetCooperativeLevel(WorkForm.hWnd, DDSCL_NORMAL)
    ddsdPrimary.lFlags = DDSD_CAPS
    ddsdPrimary.ddsCaps.lCaps = DDSCAPS_PRIMARYSURFACE
    Set Primary = dd.CreateSurface(ddsdPrimary)
    Set DDClip = dd.CreateClipper(0)
    DDClip.SetHWnd WorkForm.hWnd
    Primary.SetClipper DDClip
    ddsdBack.lFlags = DDSD_CAPS Or DDSD_HEIGHT Or DDSD_WIDTH
    ddsdBack.ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN Or DDSCAPS_SYSTEMMEMORY
    ddsdBack.lWidth = WorkForm.Width
    ddsdBack.lHeight = WorkForm.Height
    Set Back = dd.CreateSurface(ddsdBack)
    DXInitWindowDraw = True
errOut:
    DXInitWindowDraw = False
    Exit Function
End Function

Public Function DXInitDraw(WorkForm As Form) As Boolean ' DirectDraw   640480  16   
    On Local Error GoTo errOut '             
    
    Set dd = DX.DirectDrawCreate("")
    WorkForm.Show
    
    Call dd.SetCooperativeLevel(WorkForm.hWnd, DDSCL_FULLSCREEN Or DDSCL_EXCLUSIVE)
    Call dd.SetDisplayMode(640, 480, 16, 0, DDSDM_DEFAULT)


    ddsd1.lFlags = DDSD_CAPS Or DDSD_BACKBUFFERCOUNT
    ddsd1.ddsCaps.lCaps = DDSCAPS_PRIMARYSURFACE Or DDSCAPS_FLIP Or DDSCAPS_COMPLEX
    ddsd1.lBackBufferCount = 1


    Set Primary = dd.CreateSurface(ddsd1)


    Dim caps As DDSCAPS2
    caps.lCaps = DDSCAPS_BACKBUFFER
    Set Back = Primary.GetAttachedSurface(caps)


    ddsd2.lFlags = DDSD_CAPS
    ddsd2.ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN
    DXInitDraw = True
    Exit Function
errOut:
    DXInitDraw = False
    Exit Function
End Function

Public Sub DXFlipScreen() '      
    On Local Error Resume Next
    Primary.Flip Nothing, DDFLIP_WAIT
End Sub

Public Sub DXDrawSprite(DXSSprite As DirectDrawSurface7, x As Integer, y As Integer, SPLeft, SPTop, SPWidth, SPHight) '   
    On Local Error Resume Next
    Dim ddrval As Long '   .
    Dim rcRect As RECT ' ,   

    rcRect.Left = SPLeft
    rcRect.Top = SPTop
    rcRect.Right = SPLeft + SPWidth - 1
    rcRect.Bottom = SPTop + SPHight - 1

    ddrval = Back.BltFast(x, y, DXSSprite, rcRect, DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT)
End Sub

Public Sub DXDrawBack(DXSBack As DirectDrawSurface7) '   
    On Local Error Resume Next
    Dim rcRect As RECT '   
    Dim ddrval As Long
    
    rcRect.Left = 0
    rcRect.Top = 0
    rcRect.Right = 640
    rcRect.Bottom = 480
    
    ddrval = Back.BltFast(0, 0, DXSBack, rcRect, DDBLTFAST_NOCOLORKEY Or DDBLTFAST_WAIT)
End Sub

Public Function DXLoadBack(FileName As String) As DirectDrawSurface7  '   
    On Local Error Resume Next
    ddsd2.lHeight = 480
    ddsd2.lWidth = 640
    Set DXLoadBack = dd.CreateSurfaceFromFile(FileName, ddsd2)
End Function

Public Function DXLoadSprite(FileName As String, SPWidth As Integer, SPHeight As Integer, TCLow As Integer, TCHigh As Integer) As DirectDrawSurface7      '   
    On Local Error Resume Next
    Dim key As DDCOLORKEY
    
    ddsd2.lHeight = SPHeight
    ddsd2.lWidth = SPWidth
    Set DXLoadSprite = dd.CreateSurfaceFromFile(FileName, ddsd2)
    
    key.low = TCLow
    key.high = TCHigh
    DXLoadSprite.SetColorKey DDCKEY_SRCBLT, key
End Function

Public Sub DXCleanUp(WorkForm As Form)  '   DX
    On Local Error Resume Next
    Call dd.RestoreDisplayMode
    Call dd.SetCooperativeLevel(WorkForm.hWnd, DDSCL_NORMAL)
End Sub

Public Function DXInitSound(WorkForm As Form) As Boolean  ' DirectSound
    On Local Error Resume Next
    
    Set m_ds = DX.DirectSoundCreate("")
    
    If Err.Number <> 0 Then
        DXInitSound = False
        'End
    End If
 
    m_ds.SetCooperativeLevel WorkForm.hWnd, DSSCL_NORMAL
    
   
    bufferDesc.lFlags = DSBCAPS_CTRLPAN
    DXInitSound = True
End Function

Public Function DXLoadSound(FileName As String) As DirectSoundBuffer '   
    On Local Error Resume Next
    Set DXLoadSound = m_ds.CreateSoundBufferFromFile(FileName, bufferDesc, waveFormat)
End Function

Public Sub DXPlaySound(hSo As DirectSoundBuffer, x As Integer) '  (x - -       (320 - ))
    On Local Error Resume Next
    hSo.SetPan 20000 * (x / 640) - 10000
    hSo.Play 0
End Sub

Public Sub DXPrint(PrText As String, Font As DirectDrawSurface7, FontW As Integer, FontH As Integer, x As Integer, y As Integer)
    Dim nI As Integer
    Dim CharCode As Byte
    Dim CharX As Integer
    Dim CharY As Integer
    For nI = 1 To Len(PrText)
        CharCode = Asc(Mid(PrText, nI, 1)) - 32
        CharY = Int(CharCode / 32)
        CharX = CharCode - CharY * 32
        DXDrawSprite Font, x + nI * FontW, y, CharX * FontW, CharY * FontH, FontW, FontH
    Next nI
End Sub

Public Sub DXDrawBox(ByVal x1 As Long, ByVal y1 As Long, ByVal x2 As Long, ByVal y2 As Long)
    Back.DrawBox x1, y1, x2, y2
End Sub

Public Sub DXDrawText(ByVal x As Long, ByVal y As Long, ByVal Text As String, ByVal bV As Boolean)
    Back.DrawText x, y, Text, bV
End Sub
